.\"	$NetBSD: fwctl.8,v 1.7 2009/04/08 14:33:12 joerg Exp $
.\"
.\" Copyright (c) 2005 KIYOHARA Takashi
.\" All rights reserved.
.\"
.\" Copyright (c) 2002 Hidetoshi Shimokawa
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
.\" WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
.\" DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
.\" INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
.\" (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
.\" SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
.\" STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
.\" ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/usr.sbin/fwcontrol/fwcontrol.8,v 1.21 2007/10/31 05:59:17 brueffer Exp $
.\"
.Dd May 18, 2009
.Dt FWCTL 8
.Os
.Sh NAME
.Nm fwctl
.Nd IEEE1394 control utility
.Sh SYNOPSIS
.Nm
.Op Fl prt
.Op Fl b Ar pri_req
.Op Fl c Ar node
.Op Fl d Ar node
.Op Fl g Ar gap_count
.Op Fl l Ar file
.Op Fl M Ar mode
.Op Fl m Ar EUI64 | hostname
.Op Fl o Ar node
.Op Fl R Ar filename
.Op Fl S Ar filename
.Op Fl s Ar node
.Op Fl u Ar bus_num
.Sh DESCRIPTION
The
.Nm
utility is designed to provide a way for users to access and control
the
.Nx
IEEE1394 subsystem.
Without options,
.Nm
will output a list of devices that are/were connected to the bus.
.Pp
The following options are available:
.Bl -tag -width XmXEUI64XhostnameXX -offset indent
.It Fl b Ar pri_req
Set the
.Dv PRIORITY_BUDGET
register on all supported nodes.
.It Fl c Ar node
Show the configuration ROM on the node.
.It Fl d Ar node
Hex dump of the configuration ROM.
.It Fl g Ar gap_count
Broadcast
.Ar gap_count
by phy_config packet.
.It Fl l Ar file
Load hex dump file of the configuration ROM and parse it.
.It Fl M Ar modeExplicitly specify either
.Ar dv
or
.Ar mpeg
mode for the incoming stream.
Only meaningful in case of and must precede the
.Fl R
option.
If not specified, the program will try to guess.
If you get an error complaining about
.Dq format 0x20 ,
try to force the
.Ar mpeg
mode.
.It Fl m Ar EUI64 | hostname
Set default fwmem target.
Hostname will be converted to EUI64.
.It Fl o Ar node
Send a link-on PHY packet to the node.
.It Fl p
Dump PHY registers.
.It Fl R Ar filename
Receive DV or MPEG TS stream and dump it to a file.
Use Ctrl-C to stop receiving.
Some DV cameras seem not to send the stream if a bus manager exits.
If you cannot get the stream, try the following commands:
.Bd -literal -offset indent
sysctl hw.ieee1394if.try_bmr=0
fwctl -r
.Ed
.Pp
The resulting file contains raw DV data excluding isochronous header
and CIP header.
It can be handled by the
.Pa pkgsrc/multimedia/libdv
package.
The resulting MPEG TS stream can be played and sent over a network using
the VideoLAN tool
.Pa ( pkgsrc/multimedia/vlc ) .
The stream can be piped directly to
.Nm vlc ,
see
.Sx EXAMPLES .
.It Fl r
Initiate bus reset.
.It Fl S Ar filename
Send a DV file as isochronous stream.
.It Fl s Ar node
Write to the
.Dv RESET_START
register on the node.
.It Fl t
Show the topology map.
.It Fl u Ar bus_num
Specify the IEEE1394 bus number to be operated on.
.El
.Sh FILES
.Bl -tag
.It Pa /dev/fw0.0
.El
.Sh EXAMPLES
Each DV frame has a fixed size and it is easy to edit the frame order.
.Pp
.Dl "fwctl -R original.dv"
.Pp
Receive a DV stream with DV camera attached.
.Pp
.Dl "dd if=original.dv of=first.dv bs=120000 count=30"
.Pp
Get first 30 frames (NTSC).
.Pp
.Dl "dd if=original.dv of=second.dv bs=120000 skip=30 count=30"
.Pp
Get second 30 frames (NTSC).
.Pp
.Dl "cat second.dv first.dv | fwctl -S /dev/stdin"
.Pp
Swap first and second 30 frames and send them to DV recorder.
.Pp
For PAL, replace
.Dq Li bs=120000
with
.Dq Li bs=144000 .
.Pp
.Dl "fwcontrol -R file.m2t"
.Pp
Receive an MPEG TS stream from a camera producing MPEG transport stream.
This has been tested with SONY HDR-FX1E camera that produces HD
MPEG-2 stream at 25 Mbps bandwidth.
.Pp
To send the stream from the camera over the network using TCP (which
supprisingly works better with vlc), you can use
.Dl "fwcontrol -R - | nc 192.168.10.11 9000"
with
.Pa pkgsrc/net/netcat
and to receive the stream, use
.Dl nc -l -p 9000 | vlc -
.Pp
To netcast via UDP, you need to use
.Pa pkgsrc/misc/buffer ,
since vlc is not fast enough to read UDP packets from
buffers and thus it experiences dropouts when run directly.
The sending side can use
.Dl "fwcontrol -R - | nc 192.168.10.11 9000"
and to receive the stream, use
.Dl nc -l -u -p 9000 | buffer -s 10k -b 1000 -m 20m -p 5 | vlc -
.Pp
For more information on how to work with
.Nm vlc
see its documentation.
.Sh SEE ALSO
.Xr mplayer 1 ,
.Xr vlc 1 ,
.Xr fwip 4 ,
.Xr fwohci 4 ,
.Xr ieee1394if 4 ,
.Xr sbp 4
.Sh HISTORY
The
.Nm
command first appeared in
.Fx 5.0 ,
as
.Ic fwcontrol .
It was added to
.Nx 4.0
under its present name.
.Sh AUTHORS
.An Hidetoshi Shimokawa Aq simokawa@FreeBSD.org
.An Petr Holub Aq hopet@ics.muni.cz
- MPEG TS mode.
.An KIYOHARA Takashi Aq kiyohara@NetBSD.org
.Sh BUGS
This utility is still under development and provided for debugging
purposes.
Especially MPEG TS reception support is very rudimental and supports only
high-bandwidth MPEG-2 streams (fn field in CIP header equals 3).
